<?php

    require_once('../../config.php');
    require_once('lib.php');

    $id = optional_param('id', 0, PARAM_INT); // Course Module ID
    $f = optional_param('f', 0, PARAM_INT); // facetoface Module ID
    $s = optional_param('s', 0, PARAM_INT); // facetoface session ID
    $takeattendance = optional_param('takeattendance', 0, PARAM_INT); // take attendance
    $cancelform = optional_param('cancelform'); // cancel request
    $viewall = optional_param('viewall', 0, PARAM_INT);

    if ($id) {

        if (! $cm = get_record('course_modules', 'id', $id)) {
            error(get_string('error:incorrectcoursemoduleid', 'facetoface'));
        }
        if (! $course = get_record('course', 'id', $cm->course)) {
            error(get_string('error:coursemisconfigured', 'facetoface'));
        }
        if (! $facetoface = get_record('facetoface', 'id', $cm->instance)) {
            error(get_string('error:incorrectcoursemodule', 'facetoface'));
        }

    } elseif ($s) {

        if (! $session = facetoface_get_session($s)) {
            error(get_string('error:incorrectcoursemodulesession', 'facetoface'));
        }
        if (! $facetoface = get_record('facetoface', 'id', $session->facetoface)) {
            error(get_string('error:incorrectfacetofaceid', 'facetoface'));
        }
        if (! $course = get_record('course', 'id', $facetoface->course)) {
            error(get_string('error:coursemisconfigured', 'facetoface'));
        }
        if (! $cm = get_coursemodule_from_instance('facetoface', $facetoface->id, $course->id)) {
            error(get_string('error:incorrectcoursemodule', 'facetoface'));
        }

    } else {

        if (! $facetoface = get_record('facetoface', 'id', $f)) {
            error(get_string('error:incorrectfacetofaceid', 'facetoface'));
        }
        if (! $course = get_record('course', 'id', $facetoface->course)) {
            error(get_string('error:coursemisconfigured', 'facetoface'));
        }
        if (! $cm = get_coursemodule_from_instance('facetoface', $facetoface->id, $course->id)) {
            error(get_string('error:incorrectcoursemodule', 'facetoface'));
        }
    }

    $sessiondate = NULL;
    $datetimestart = make_timestamp(2000, 1, 1, 9, 0, 0);
    $datetimefinish = make_timestamp(2000, 1, 1, 12, 0, 0);

    require_course_login($course);
    $context = get_context_instance(CONTEXT_COURSE, $course->id);
    require_capability('mod/facetoface:view', $context);

    if ($form = data_submitted()) {
        require_capability('mod/facetoface:takeattendance', $context);

        if ($cancelform) {
            redirect('attendees.php?s='.$s, '', '4');
        } elseif (facetoface_take_attendance($form)) {
            add_to_log($course->id, 'facetoface', get_string('log:takeattendance', 'facetoface'), "view.php?id=$cm->id", $facetoface->id, $cm->id);
        } else {
            add_to_log($course->id, 'facetoface', get_string('log:takeattendance', 'facetoface').get_string('log:failed', 'facetoface'), "view.php?id=$cm->id", $facetoface->id, $cm->id);
        }

    }
    $strfacetofaces = get_string('modulenameplural', 'facetoface');
    $strfacetoface = get_string('modulename', 'facetoface');

    print_header_simple($facetoface->name, '', '<a href="index.php?id='.$course->id.'">'.$strfacetofaces.'</a> -> <a href="view.php?f='.$facetoface->id.'">'.$facetoface->name.'</a> -> '.get_string('attendees', 'facetoface'), '', '', true, update_module_button($cm->id, $course->id, $strfacetoface), navmenu($course, $cm));

    if ($takeattendance && !has_capability('mod/facetoface:takeattendance', $context)) {
        $takeattendance = 0;
    }

    if ($takeattendance) {
        $heading = get_string('takeattendance', 'facetoface');
    } else {
        add_to_log($course->id, 'facetoface', get_string('log:viewattendees', 'facetoface'), "view.php?id=$cm->id", $facetoface->id, $cm->id);
        $heading = get_string('attendees', 'facetoface');
    }
    if ($session->datetimeknown) {
        $allsessiondates = '';
        foreach ($session->sessiondates as $date) {
            $allsessiondates .= '<tr>';
            $allsessiondates .= '<td align="right">'.userdate($date->timestart, get_string('strftimedaydate')).
                ',</td><td align="left">'.userdate($date->timestart, get_string('strftimetime')).
                ' - '.userdate($date->timefinish, get_string('strftimetime')).'</td>';
            $allsessiondates .= '</tr>';
        }

        $subheading = $facetoface->name.' - '.$session->venue.'<br /><table border="0">'.$allsessiondates.'</table>';
    } else {
        $subheading = $facetoface->name.' - '.$session->location.'<br />'.get_string('wait-list', 'facetoface');
    }

    print_heading($heading, 'center');
    echo '<center>';
    echo '<strong>'.$subheading.'</strong>';
    echo '</center>';
    echo '<br />';

    if ($takeattendance) {
        echo '<center><span style="font-size: 12px; line-height: 18px;">';
        echo get_string('attendanceinstructions', 'facetoface');
        echo '</span></center><br />';
    }

    $table = '';

    if ($takeattendance) {
        $table .= '<form action="attendees.php?s='.$s.'" method="post">';
        $table .= '<input type="hidden" name="s" value="'.$s.'" />';
        $table .= '<input type="hidden" name="action" value="1" />';
    }
    $table .= '<table align="center" cellpadding="3" cellspacing="0" width="600" style="border-color:#DDDDDD; border-width:1px 1px 1px 1px; border-style:solid;">';
    $table .= '<tr>';
    $table .= '<th class="header" align="left">&nbsp;'.get_string('name').'</th>';
    if (has_capability('mod/facetoface:viewattendees', $context)) {
        if ($takeattendance) {
            $table .= '<th class="header" align="center" width="40%">'.get_string('attendedsession', 'facetoface').'</th>';
        } else {
            if (!get_config(NULL, 'facetoface_hidecost')) {
                $table .= '<th class="header" align="center">'.get_string('cost', 'facetoface').'</th>';
                if (!get_config(NULL, 'facetoface_hidediscount')) {
                    $table .= '<th class="header" align="center">'.get_string('discountcode', 'facetoface').'</th>';
                }
            }
            $table .= '<th class="header" align="center">'.get_string('attendance', 'facetoface').'</th>';
        }
    }
    $table .= '</tr>';

    if ($attendees = facetoface_get_attendees($session->id)) {

        foreach($attendees as $attendee) {
            $table .= '<tr>';
            $table .= '<td>&nbsp;<a href="'.$CFG->wwwroot.'/user/view.php?id='.$attendee->id.'">'.$attendee->firstname.', '.$attendee->lastname.'</a></td>';
            if (has_capability('mod/facetoface:viewattendees', $context)) {
                if ($takeattendance) {
                    $var = 'submissionid_'.$attendee->submissionid;
                    $$var = optional_param($var,0);
                    $checkbox = print_checkbox($var, $$var, $$var, '', '', '', true);
                    $table .= '<td align="center">'.$checkbox.'</td>';
                } else {
                    if (!get_config(NULL, 'facetoface_hidecost')) {
                        $table .= '<td align="center">'.facetoface_cost($attendee->id, $session->id, $session).'</td>';
                        if (!get_config(NULL, 'facetoface_hidediscount')) {
                            $table .= '<td align="center">'.$attendee->discountcode.'</td>';
                        }
                    }
                    $table .= '<td align="center">'.$attendee->grade.'</td>';
                }
            }
            $table .= '</tr>';
        }

    } else {
        $table .= '<tr>';
        if (has_capability('mod/facetoface:viewattendees', $context)) {
            $table .= '<td colspan="2">&nbsp;'.get_string('nosignedupusers', 'facetoface').'</td>';
        } else  {
            $table .= '<td>&nbsp;'.get_string('nosignedupusers', 'facetoface').'</td>';
        }
        $table .= '</tr>';
        
    }
    $table .= '</table>';
    if ($takeattendance) {
        $table .= '<br /><center>';
        $table .= '<input type="submit" value="'.get_string('saveattendance', 'facetoface').'" />';
        $table .= '&nbsp;<input type="submit" name="cancelform" value="'.get_string('cancel').'" />';
        $table .= '</center>';

        $table .= '</form>';
    }
    echo $table;

    // Actions
    print '<p style="text-align: center">';
    if (has_capability('mod/facetoface:takeattendance', $context)) {
        if (!$takeattendance and !empty($attendees)) {
            // Take attendance
            echo '<a href="'.$CFG->wwwroot.'/mod/facetoface/attendees.php?s='.$session->id.'&amp;takeattendance=1">'.get_string('takeattendance', 'facetoface').'</a> - ';
        }
    }
    if (has_capability('mod/facetoface:editattendees', $context)) {
        // Add/remove attendees
        echo '<a href="'.$CFG->wwwroot.'/mod/facetoface/editattendees.php?s='.$session->id.'">'.get_string('addremoveattendees', 'facetoface').'</a> - ';
    }
    $url = $CFG->wwwroot.'/course/view.php?id='.$course->id;
    if ($viewall) {
        $url = $CFG->wwwroot.'/mod/facetoface/view.php?f='.$facetoface->id.'&amp;viewall='.$viewall;
    }
    print '<a href="'.$url.'">'.get_string('goback', 'facetoface').'</a></p>';

    print_footer($course);

?>
