<?php  //$Id: upgrade.php,v 1.3 2008/07/30 05:30:19 fmarier Exp $

// This file keeps track of upgrades to 
// the facetoface module
//
// Sometimes, changes between versions involve
// alterations to database structures and other
// major things that may break installations.
//
// The upgrade function in this file will attempt
// to perform all the necessary actions to upgrade
// your older installtion to the current version.
//
// If there's something it cannot do itself, it
// will tell you what you need to do.
//
// The commands in here will all be database-neutral,
// using the functions defined in lib/ddllib.php

function xmldb_facetoface_upgrade($oldversion=0) {

    global $CFG, $THEME, $db;

    $result = true;

    if ($result && $oldversion < 2008050500) {
        $table = new XMLDBTable('facetoface');
        $field = new XMLDBField('thirdpartywaitlist');
        $field->setAttributes(XMLDB_TYPE_INTEGER, '1', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null, null, '0', 'thirdparty');
        $result = $result && add_field($table, $field);
    }

    if ($result && $oldversion < 2008061000) {
        $table = new XMLDBTable('facetoface_submissions');
        $field = new XMLDBField('notificationtype');
        $field->setAttributes(XMLDB_TYPE_INTEGER, '10', XMLDB_UNSIGNED, XMLDB_NOTNULL, null, null, null, '0', 'timemodified');
        $result = $result && add_field($table, $field);
    }

    return $result;
}

?>
